#version 410 core

//----------------------------------------------
// TESSELLATION EVALUATION SHADER
// C EST LE TROISIEME PROGRAMME EXECUTE PAR LA CARTE GRAPHIQUE
//----------------------------------------------

// LE PATCH ABSTRAIT EST UN QUAD. MAIS ON RECOIT QUAND MEME UN NOMBRE ARBITRAIRE DE POINTS DE CONTROLE
layout(quads, fractional_even_spacing) in;

// EN ENTREE ON DISPOSE D'UN TABLEAU CONTENANT LES XXX POINTS DE CONTROLE DU PATCH 
// LE NOMBRE XXX ESAVECT DEFINI DANS LE PROGRAMME C++ PAR LA LIGNE glPatchParameteri(GL_PATCH_VERTICES, 4);
// AINSI QUE LES DEUX PARAMETRES gl_TessCoord.x ET gl_TessCoord.y RETOURNES PAR LE TESSELLATION CONTROL SHADER
in gl_PerVertex {
        vec3 gl_Position;
    } gl_in[];


// CALCUL L INTERPOLATION BILINEAIRE DES 4 SOMMETS DU PATCH AVEC LES COORDONNEES gl_TessCoord.x, glTessCoord.y
void main()
{
	vec3 P1 = mix( gl_in[0].gl_Position,  gl_in[1].gl_Position, gl_TessCoord.x);
	vec3 P2 = mix( gl_in[2].gl_Position,  gl_in[3].gl_Position, gl_TessCoord.x);
	vec3 P = mix( P1, P2, gl_TessCoord.y);
//	gl_Position = vec4( gl_TessCoord.x, gl_TessCoord.y, 0., 1.); // POUR VISUALISER LES COORDONNEES DE TESSELLATION
	gl_Position = vec4( P, 1.);
}
